<?php

class weather {

    /** Api key from wunderground.com @var string */
    private $get = 'conditions/forecast10day';
    private $apiKey;
    private $location;
		
	/** Your lang @var string */
    private $lang = 'EN';
    private $json;
    public function __construct($apiKey, $location) {
        $this->apiKey = $apiKey;
		$this->location = $location;
		$this->getAllWeather();
    }
	
    /** Get weather from api ,decode and save in $json */
    private function getAllWeather() {
        $apiUrl = 'http://api.wunderground.com/api/' . $this->apiKey . '/' . $this->get . '/q/' . $this->location . '/'. '.json';
        $this->json = json_decode(file_get_contents($apiUrl));
    }

    public function getForecast0($c = true) {
        if ($c) {
            $out = $this->json->forecast->txt_forecast->forecastday[0]->fcttext_metric;
        } else {
            $out = $this->json->forecast->txt_forecast->forecastday[0]->fcttext;
        }
        return $out;
    }	

    /** GetIcon @return string */
    public function getIcon0() {
         $out = $this->json->forecast->simpleforecast->forecastday[0]->icon;
         return $out;
    }

	 /** Get City Name @return string */
    public function getCityName() {
		 $out = $this->json->current_observation->observation_location->city;
         return $out;
    }
	
	 /** Get Epoch @return string */
    public function getEpoch() {
          $out = $this->json->current_observation->local_epoch;
         return $out;
		 }
		 
    /** Get Current Temp_c @return string */
    public function getCurrentTemp() {
          $out = $this->json->current_observation->temp_c;
         return $out;
		 }
	
    /** Get getCurrentHumidity @return string */
    public function getCurrentHumidity() {
          $out = $this->json->current_observation->relative_humidity;
         return $out;
		 }	

	 /** Get getCurrentPressure @return string */
    public function getCurrentPressure() {
          $out = $this->json->current_observation->pressure_mb;
         return $out;
	}
	
    // Start 4 Day report

	 /** Get Report Date @return string */
    public function getEpochForecast($Day) {
        $out = $this->json->forecast->simpleforecast->forecastday[$Day]->date->epoch;
        return $out;
        }
	
	/** Get Max Temp @return string */
    public function getTempHigh($Day) {
          $out = $this->json->forecast->simpleforecast->forecastday[$Day]->high->celsius;
         return $out;
	}
	
	 /** Get Min Temp @return string */
    public function getTempLow($Day) {
          $out = $this->json->forecast->simpleforecast->forecastday[$Day]->low->celsius;
         return $out;
	}
	
	 /** Get Conditions @return string */
    public function getIcon($Day) {
          $out = $this->json->forecast->simpleforecast->forecastday[$Day]->icon;
         return $out;
	}
	
	/** Get SunRise & Sunset @return string */
    public function getSunRise($Day) {
	/* calculate the sunrise time */
    $day = $this->json->forecast->simpleforecast->forecastday[$Day]->date->day;
	$month = $this->json->forecast->simpleforecast->forecastday[$Day]->date->month;
	$year = $this->json->forecast->simpleforecast->forecastday[$Day]->date->year;
    $lat = $this->json->current_observation->observation_location->latitude;
	$long = $this->json->current_observation->observation_location->longitude;

    $sun_info = date_sun_info(strtotime($year."-".$month."-".$day), $lat, $long);
	$out = date("H:i:s", $sun_info[sunrise]); 
        return $out;
	}
	
	 /** Get SunSet @return string */
    public function getSunSet($Day) {
	/* calculate the sunrise time */
    $day = $this->json->forecast->simpleforecast->forecastday[$Day]->date->day;
	$month = $this->json->forecast->simpleforecast->forecastday[$Day]->date->month;
	$year = $this->json->forecast->simpleforecast->forecastday[$Day]->date->year;
    $lat = $this->json->current_observation->observation_location->latitude;
	$long = $this->json->current_observation->observation_location->longitude;

    $sun_info = date_sun_info(strtotime($year."-".$month."-".$day), $lat, $long);
	$out = date("H:i:s", $sun_info[sunset]); 
        return $out;
	}
	 		
	/** Get windSpeed @return string */
    public function getWindSpeed($Day) {
          $out = $this->json->forecast->simpleforecast->forecastday[$Day]->avewind->kph;
		 return $out;
	}
	
	/** Get WindDir @return string */
    public function getWindDir($Day) {
          $out = $this->json->forecast->simpleforecast->forecastday[$Day]->avewind->dir;
		 return $out;
	}
	
	/** Get Conditions_Metric @return string */
	    public function getConditions_Metric($Day) {
         $out = $this->json->forecast->txt_forecast->forecastday[$Day]->fcttext_metric;
	    return $out;
	}
			
    /** Set Language, http://www.wunderground.com/weather/api/d/docs?d=language-support * @param string $lang */
    public function setLang($lang) {
       $this->lang = $lang;
    }

    /** @param string $apiKey */
    public function setApiKey($apiKey) {
        $this->apiKey = $apiKey;
    }
}
?>
